#include "stdafx.h"
#include "Tactics.h"
#include "VixarLibrary.h"
#include <fstream>

using namespace std;

#define MAX_LOADSTRING 100
#define WINDOW_MODE   true //EBhE[h(true)tXN[[h(false)߂
#define WINDOW_WIDTH  640  //EBhẺ
#define WINDOW_HEIGHT 480  //EBhȄc
#define MAP_WIDTH  10
#define MAP_HEIGHT 10

// O[oϐ:
HWND hWnd;							//EBhEnhO[oŐ錾
HINSTANCE hInst;								// ݂̃C^[tFCX
TCHAR szTitle[MAX_LOADSTRING];					// ^Cg o[̃eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// C EBhE NX

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
void ReleaseDirectX9(void);		//DirectX9̉

//DirectXGraphics|C^
CDirectXGraphics* vlGraphics = NULL;
//DirectInput|C^
CDirectInput*	  vlInput    = new CDirectInput();
//DirectSound|C^
CDirectSound*	  vlSound    = new CDirectSound();
//LN^[
CCharacter* vlCharacter = new CCharacter();
//LN^[
CCharacter* vlGround[MAP_WIDTH*MAP_HEIGHT];
//L[{[h
int KeyLeft,KeyRight,KeyUp,KeyDown;

//------------------------------------------------------------------------
//}bv̓ǂݍ
//------------------------------------------------------------------------
bool Load(char* filename)
{
	ifstream stream;
	stream.open(filename,ios::in | ios::binary);//oCiŊJ
	if (!stream.is_open()) // G[`FbN
	{
        return false;
    }

	//ۑ}bvYWf[^̓ǂݍ
	float y;
	for ( int i = 0; i < MAP_WIDTH*MAP_HEIGHT; ++i )
	{
		stream >> y;
		vlGround[i]->SetScale(1,y,1);
	}

	stream.close();  // 

	return true;
}

//------------------------------------------------------------------------
//
//------------------------------------------------------------------------
BOOL Init()
{
	//DirectX9쐬
	vlGraphics = new CDirectXGraphics(hWnd,WINDOW_MODE,WINDOW_WIDTH,WINDOW_HEIGHT);
	vlGraphics->SetBgColor(180,220,255);
	//LN^[ǂݍ
	if ( !vlCharacter->LoadMQAFile("MQA\\BlueKnight.mqa",vlGraphics->GetD3DDevice()) )
	{
		return FALSE;
	}
	vlGround[0] = new CCharacter();
	if ( !vlGround[0]->LoadMQAFile("MQO\\Tactics.mqo",vlGraphics->GetD3DDevice()) )
	{
		return FALSE;
	}
	for ( int i = 1; i < MAP_WIDTH*MAP_HEIGHT; ++i )
	{
		vlGround[i] = new CCharacter();
		vlGround[i]->Copy(vlGround[0]);
	}
	char file_name[256];
	sprintf(file_name,"%sStage1.vtm",GetDirectory());
	Load(file_name);

	//DirectInput쐬
	if ( vlInput->CreateDirectInput(hWnd) != S_OK )
	{
		return FALSE;
	}

	//TEh
	vlSound->Init(hWnd);

	return TRUE;
}

//------------------------------------------------------------------------
// `
//------------------------------------------------------------------------
void Draw()
{
	D3DXVECTOR3 pos = vlCharacter->GetPosition();
	D3DXMATRIX trans;
	D3DXMATRIX rotateY;
	float radian;

	//L[{[h擾
	vlInput->GetKeyboardInput(DIK_LEFT,KeyLeft);
	vlInput->GetKeyboardInput(DIK_RIGHT,KeyRight);
	vlInput->GetKeyboardInput(DIK_UP,KeyUp);
	vlInput->GetKeyboardInput(DIK_DOWN,KeyDown);	
	//[]L[
	if ( KeyLeft == PUSH_KEY && pos.x > 0 )
	{
		pos.x -= 100;
		vlCharacter->SetRotate(0,-90,0);
	}
	else if ( KeyRight == PUSH_KEY && pos.x < (MAP_WIDTH-1)*100 )	//[]L[
	{
		pos.x += 100;
		vlCharacter->SetRotate(0,90,0);
	}
	else if ( KeyUp == PUSH_KEY && pos.z > 0 )	//[]L[
	{
		pos.z -= 100;
		vlCharacter->SetRotate(0,180,0);
	}
	else if ( KeyDown == PUSH_KEY && pos.z < (MAP_HEIGHT-1)*100 )	//[]L[
	{
		pos.z += 100;
		vlCharacter->SetRotate(0,0,0);
	}
	//LN^[̍(YW)̈ʒunʂ̍ɍ킹
	int ground = (int)(pos.z/100)*MAP_HEIGHT+(int)(pos.x/100);
	pos.y = vlGround[ground]->GetScale().y*50;
	//ړ
	D3DXMatrixTranslation(&trans,pos.x,pos.y,pos.z);
	//Y]
	radian = D3DXToRadian(vlCharacter->GetRotateY());
	D3DXMatrixRotationY(&rotateY,radian);
	//ϊs̃Zbg
	vlCharacter->SetTransform(rotateY*trans);

	//nʂ̈ʒũZbg(nʂ̍YɊg)
	for ( int i = 0; i < MAP_WIDTH*MAP_HEIGHT; ++i )
	{
		D3DXMATRIX trans;
		D3DXMATRIX scale;
		D3DXMatrixTranslation(&trans,float((i%10)*100),0,float(int(i/10)*100));
		D3DXMatrixScaling(&scale,1,vlGround[i]->GetScale().y,1);
		vlGround[i]->SetTransform(scale*trans);
	}

//---------------------------`揈---------------------------
	//`揈Jn
	vlGraphics->BeginRendering();

	//_
	D3DXVECTOR3 eye = pos + D3DXVECTOR3(2000,1000,2000);
	//_
	D3DXVECTOR3 at  = pos + D3DXVECTOR3(0,0,0);
	//Cg
	vlGraphics->SetLight(at-eye);
	//J
	vlGraphics->SetCamera(eye,at);
	//LN^[`
	vlCharacter->TransformAndDrawModels(vlGraphics->GetD3DDevice());
	//nʕ`
	for ( int i = 0; i < MAP_WIDTH*MAP_HEIGHT; ++i )
	{
		vlGround[i]->TransformAndDrawModels(vlGraphics->GetD3DDevice());
	}

	//`I
	vlGraphics->EndRendering();
//---------------------------܂ŕ`揈---------------------------
}

//-------------------------------------------------------------------------
//DirectX9̉
//-------------------------------------------------------------------------
void ReleaseDirectX9()
{
	//^C}[I
	KillTimer(hWnd,1);
	//TEh
	SAFE_DELETE(vlSound);
	//DirectInput
	SAFE_DELETE(vlInput);
	//nʉ
	SAFE_DELETE(vlGround[0]);
	//LN^[
	SAFE_DELETE(vlCharacter);
	//DirectGraphics
	SAFE_DELETE(vlGraphics);
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: ɃR[h}ĂB
	MSG msg;
	HACCEL hAccelTable;

	// O[oĂ܂B
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_TACTICS, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// AvP[V̏s܂:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_TACTICS));

	//
	if ( !Init() )
	{
		return FALSE;
	}

	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  ֐: MyRegisterClass()
//
//  ړI: EBhE NXo^܂B
//
//  Rg:
//
//    ̊֐юǵA'RegisterClassEx' ֐ǉꂽ
//    Windows 95 O Win32 VXeƌ݊ꍇɂ̂ݕKvłB
//    AvP[VA֘Atꂽ
//    `̏ACR擾ł悤ɂɂ́A
//    ̊֐ĂяoĂB
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_TACTICS));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_TACTICS);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI: CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	hInst = hInstance; // O[oϐɃCX^Xi[܂B

    	//EBhE[hȂ
    	if(WINDOW_MODE == true)
    	{
		hWnd = CreateWindow(
			szWindowClass,
			szTitle,
            WS_OVERLAPPEDWINDOW & ~(WS_THICKFRAME | WS_MAXIMIZEBOX),
            0,0,640,480,
			NULL, NULL, hInstance, NULL);
    
        RECT wRect,cRect;	 //EBhEŜ̃TCYƃNCAg̃TCYϐ
        int W_WIDTH,W_HEIGHT;//EBhE̕ƍϐ
        int C_WIDTH,C_HEIGHT;//NCAg̕ƍϐ
        int S_WIDTH,S_HEIGHT;//EBhE̊Og̕ƍϐ
        int M_WIDTH,M_HEIGHT;//w肵EBhẼTCYϐ
    
        GetWindowRect(hWnd,&wRect);//EBhEŜ̍WƍW߂
        W_WIDTH = wRect.right - wRect.left; //EBhE̕߂
        W_HEIGHT = wRect.bottom - wRect.top;//EBhE̍߂
    
        GetClientRect(hWnd,&cRect);//NCAg̍WƍW߂
        C_WIDTH = cRect.right - cRect.left; //NCAg̕߂
        C_HEIGHT = cRect.bottom - cRect.top;//NCAg̍߂
    
        //EBhEŜ̕ƃNCAg̕ƊOg̕܂
        S_WIDTH = W_WIDTH - C_WIDTH;
        //EBhEŜ̍ƃNCAg̍ƊOg̍܂
        S_HEIGHT = W_HEIGHT - C_HEIGHT;
    
        M_WIDTH = WINDOW_WIDTH + S_WIDTH;
        M_HEIGHT = WINDOW_HEIGHT + S_HEIGHT;
    
        // vZƍEBhEɐݒ
        SetWindowPos(hWnd, HWND_TOP, 0, 0, M_WIDTH, M_HEIGHT, SWP_NOMOVE);
    }
	else//tXN[[hȂ
	{
        //EBhE̍쐬
        hWnd = CreateWindow(
			szWindowClass,
			szTitle,
            //tXN[[hȂWS_VISIBLEWS_POPw肷
            WS_VISIBLE | WS_POPUP,
            0,0,WINDOW_WIDTH,WINDOW_HEIGHT,
            NULL,NULL,hInst,NULL
        );
    }

	if (!hWnd)
	{
       	 	MessageBox(NULL,TEXT("EBhE̍쐬Ɏs܂"),NULL,MB_OK);
		return FALSE;
	}

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	//^C}[̃Zbg
	SetTimer(hWnd,1,33,NULL);

   	return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI:  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_TIMER: //^C}[
		Draw();
		break;
	case WM_ACTIVATE:
		// EBhEANeBu鎞
		if(vlInput)
		{
			if(WA_INACTIVE==wParam)
			{
				vlInput->SetAcquire(FALSE);
			}
			else
			{
				vlInput->SetAcquire(TRUE);
			}
		}
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Iꂽj[̉:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: `R[hɒǉĂ...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		//DirectX9̏I
	    ReleaseDirectX9();
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
